



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【Java并发编程】：并发新特性—障碍器CyclicBarrier</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【Java并发编程】：并发新特性—障碍器CyclicBarrier</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-12 08:17:56 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>CyclicBarrier（又叫障碍器）同样是<a href="http://lib.csdn.net/base/java" rel="external nofollow noreferrer">Java</a>5中加入的新特性，使用时需要导入<a href="http://lib.csdn.net/base/javase" rel="external nofollow noreferrer">Java</a>.util.concurrent.CylicBarrier。它适用于这样一种情况：你希望创建一组任务，它们并发地执行工作，另外的一个任务在这一组任务并发执行结束前一直阻塞等待，直到该组任务全部执行结束，这个任务才得以执行。这非常像CountDownLatch，只是CountDownLatch是只触发一次的事件，而CyclicBarrier可以多次重用。</p>
<p>下面给出一个简单的实例来说明其用法：</p>
<div>
<ol><li>import&nbsp;java.util.concurrent.BrokenBarrierException;</li>
<li>import&nbsp;java.util.concurrent.CyclicBarrier;</li>
<li>public&nbsp;class&nbsp;CyclicBarrierTest&nbsp;{</li>
<li>public&nbsp;static&nbsp;void&nbsp;main(String[]&nbsp;args)&nbsp;{</li>
<li>//创建CyclicBarrier对象，</li>
<li>//并设置执行完一组5个线程的并发任务后，再执行MainTask任务</li>
<li>CyclicBarrier&nbsp;cb&nbsp;=&nbsp;new&nbsp;CyclicBarrier(5,&nbsp;new&nbsp;MainTask());</li>
<li>new&nbsp;SubTask("A",&nbsp;cb).start();</li>
<li>new&nbsp;SubTask("B",&nbsp;cb).start();</li>
<li>new&nbsp;SubTask("C",&nbsp;cb).start();</li>
<li>new&nbsp;SubTask("D",&nbsp;cb).start();</li>
<li>new&nbsp;SubTask("E",&nbsp;cb).start();</li>
<li>}</li>
<li>}</li>
<li>/**</li>
<li>*&nbsp;最后执行的任务</li>
<li>*/</li>
<li>class&nbsp;MainTask&nbsp;implements&nbsp;Runnable&nbsp;{</li>
<li>public&nbsp;void&nbsp;run()&nbsp;{</li>
<li>System.out.println("......终于要执行最后的任务了......");</li>
<li>}</li>
<li>}</li>
<li>/**</li>
<li>*&nbsp;一组并发任务</li>
<li>*/</li>
<li>class&nbsp;SubTask&nbsp;extends&nbsp;Thread&nbsp;{</li>
<li>private&nbsp;String&nbsp;name;</li>
<li>private&nbsp;CyclicBarrier&nbsp;cb;</li>
<li>SubTask(String&nbsp;name,&nbsp;CyclicBarrier&nbsp;cb)&nbsp;{</li>
<li>this.name&nbsp;=&nbsp;name;</li>
<li>this.cb&nbsp;=&nbsp;cb;</li>
<li>}</li>
<li>public&nbsp;void&nbsp;run()&nbsp;{</li>
<li>System.out.println("[并发任务"&nbsp;+&nbsp;name&nbsp;+&nbsp;"]&nbsp;&nbsp;开始执行");</li>
<li>for&nbsp;(int&nbsp;i&nbsp;=&nbsp;0;&nbsp;i&nbsp;&lt;&nbsp;999999;&nbsp;i++)&nbsp;;&nbsp;&nbsp;&nbsp;&nbsp;//模拟耗时的任务</li>
<li>System.out.println("[并发任务"&nbsp;+&nbsp;name&nbsp;+&nbsp;"]&nbsp;&nbsp;开始执行完毕，通知障碍器");</li>
<li>try&nbsp;{</li>
<li>//每执行完一项任务就通知障碍器</li>
<li>cb.await();</li>
<li>}&nbsp;catch&nbsp;(InterruptedException&nbsp;e)&nbsp;{</li>
<li>e.printStackTrace();</li>
<li>}&nbsp;catch&nbsp;(BrokenBarrierException&nbsp;e)&nbsp;{</li>
<li>e.printStackTrace();</li>
<li>}</li>
<li>}</li>
<li>}</li></ol>
</div>
<p>某次执行的结果如下：</p>
<p>[并发任务A] &nbsp;开始执行<br />
[并发任务B] &nbsp;开始执行<br />
[并发任务D] &nbsp;开始执行<br />
[并发任务E] &nbsp;开始执行<br />
[并发任务A] &nbsp;开始执行完毕，通知障碍器<br />
[并发任务E] &nbsp;开始执行完毕，通知障碍器<br />
[并发任务D] &nbsp;开始执行完毕，通知障碍器<br />
[并发任务C] &nbsp;开始执行<br />
[并发任务B] &nbsp;开始执行完毕，通知障碍器<br />
[并发任务C] &nbsp;开始执行完毕，通知障碍器<br />
......终于要执行最后的任务了......</p>
<p>从结果可以看出：MainTask任务在一组中的5个任务执行完后才开始执行。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlp07k9.html">C语言关键字、标识符和注释</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mx5gp9.html">Native code on Windows Phone 8（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z23rn8.html">Android快速开发系列 10个常用工具类</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql3lgkq.html">android定义启动唯一apk</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93m72n8.html">ServiceLocator是反模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1znxj9.html">Centos6快速yum lamp</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0y6ggq.html">android之PackageManager简单介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy147pxq.html">这个发现是否会是RSA算法的BUG、或者可能存在的破解方式？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jglwl8.html">基于FPGA的腐蚀膨胀算法实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj05mk9.html">java1&period;8十大新特性详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k1nm09.html">变量前缀&lowbar;&lowbar;device&lowbar;&lowbar;以及&lowbar;&lowbar;managed&lowbar;&lowbar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j10lzl9.html">vue修改框架样式&sol;deep&sol;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rjpe49.html">No Spring WebApplicationInitializer types detected on classpath</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwxlwd8.html">Codeforces 865C Gotta Go Fast  二分 &plus; 期望dp &lpar;看题解&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjr5l69.html">深拷贝 浅拷贝  python</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r12mn9.html">详细的最新版fastdfs单机版搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1x4m49.html">mysql启动失败一例</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwogdz8.html">Redis性能监控</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjxny59.html">C语言中sizeof与strlen的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4png63q.html">gradle 编译 No such property&colon; sonatypeUsername错误解决</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9jmlzvl9.html">用原生的javascript 实现一个无限滚动的轮播图</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pdzo0q.html">Java 注解概要</a>
			</li>
						<li><a href="https://www.batexi.com/a/963dpv49.html">python将字典中的数据保存到文件中</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pdjgeq.html">VHDL的库</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zk3kw18.html">MFC中添加新的对话框</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1vo2x9.html">快速排序&mdash;三路快排 vs 双基准</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvekzrz9.html">Java实现wc部分功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvg4ljq.html">Intellij IDEA 14的注册机（Java版）</a>
			</li>
						<li><a href="https://www.batexi.com/a/902ye5oq.html">C&num; 获取相对路径&lpar;绝对路径转相对路径&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jml2j49.html">Git Commit 标准化</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
